//-----------------------------------------
// Global Variables Declaration
//-----------------------------------------

minx = miny = maxx = maxy = lastx = lasty = 
zoomedwidth = zoomedheight = oldsx = oldsy = 
casx = casy = 0; 
rot = 90;
ax = ay = null;
model = 0;
beforeeditwidgetopacity = preferences.konfabulatorWindowOpacity.value;
flyarea = 1;

//it moves on it's own, no need for the user to drag it...
preferences.konfabulatorLockWindowPosition.hidden = true;

//-----------------------------------------
// Functions
//-----------------------------------------

function PrefChanged()
{
	//fps
	HeartTimer.interval = 1 - (Number(preferences.framerate.value) / 1000);
	//butterfly model
	randommodeltimer.ticking = false;
	if (preferences.model.value == 0) //random
	{
		randommodeltimer.interval = Number(preferences.modelrandomtime.value);
		randommodeltimer.ticking = (preferences.modelrandomtime.value != '0');
		RandomChangeModel();
	}
	else ChangeModel(preferences.model.value);
	//resize
	shadow.width = body.width = wing1.width = wing2.width = shadow.srcWidth * preferences.size.value / 100;
	shadow.height = body.height = wing1.height = wing2.height = shadow.srcHeight * preferences.size.value / 100;
	zoomedwidth = shadow.width;
	zoomedheight = shadow.height;
	//shadow
	shadow.opacity = preferences.dropshadow.value;
	//reinit movement boundary
	flyarea = preferences.flyarea.value;
	SetFlyingArea();
	if (ecaw.visible == 0) Fly();
	//show EditCustomAreaWindow ?...
	if (preferences.editcustomarea.value == 1) ShowCustomFlyingAreaEditor();
	body.onMouseDown = (preferences.showprefonclick.value == 1) ? showWidgetPreferences : null ;
}

function mwContextMenu()
{
	var mi = new Array();
	mi[1] = new MenuItem();
	mi[1].title = "Edit Custom Flying Area...";
	mi[1].onSelect = ShowCustomFlyingAreaEditor;
	mi[1].enabled = (preferences.flyarea.value == 3);
	
	mw.contextMenuItems = mi;
}

function ShowCustomFlyingAreaEditor()
{	
	preferences.editcustomarea.value == 0;
	Stop();
	showArea(preferences.boxarea.value.split('|'));
	//record user selected widget opacity
	beforeeditwidgetopacity = preferences.konfabulatorWindowOpacity.value;
	preferences.konfabulatorWindowOpacity.value = 255;
	//avoid fade
	ecaw.opacity = 0;
	ecaw.visible = true;
	ecaw.opacity = 255;
}

function ChangeModel(modelnumber)
{
	model = modelnumber;
	shadow.src='Images/butterfly' + model + '/shadow.png';
	body.src='Images/butterfly' + model + '/body.png';
	wing1.src='Images/butterfly' + model + '/wing1.png';
	wing2.src='Images/butterfly' + model + '/wing2.png';
}

function RandomChangeModel()
{
	newmodel = model;
	while (model == newmodel) newmodel = Math.ceil(Math.random() * (preferences.model.option.length - 1)); //use length - 1 cause we may add more models
	ChangeModel(newmodel);
	if (preferences.usepoof.value == 1) Poof();
}

function Poof()
{
	poof1.width = poof2.width = body.width;
	poof1.height = poof2.height = body.height;
	poof1.rotation = Math.random() * 360;
	poof2.rotation = Math.random() * 360;
	pw.hOffset = mw.hOffset;
	pw.vOffset = mw.vOffset;
	animator.start([	new ResizeAnimation(poof1, poof1.width * 1.5, poof1.height * 1.5, 500, animator.kEaseOut), 
				new ResizeAnimation(poof2, poof2.width * 1.5, poof2.height * 1.5, 800, animator.kEaseOut), 
				new RotateAnimation(poof1, poof1.rotation - 10, 500, animator.kEaseOut), 
				new RotateAnimation(poof2, poof2.rotation + 15, 800, animator.kEaseOut), 
				new FadeAnimation(poof1, 0, 500, animator.kEaseNone), 
				new FadeAnimation(poof2, 0, 800, animator.kEaseNone, PoofDone)]);
	poof1.visible = poof2.visible = true;
}

function PoofDone()
{
	poof1.visible = poof2.visible = false;
	poof1.opacity = 255;
	poof2.opacity = 191;
}

function SetFlyingArea()
{
	switch (flyarea)
	{
		case '0': //"It's a butterfly, let it go wild!"
		{	//also handled in HeartBeat
			IAmNotANumberIAmAFreeButterfly();
			break;
		}
		case '1': //"Screen Only"
		{
			TheWholeScreenIsYourGarden();	
			break;
		}
		case '2': //"Go Beyound Screen"
		{
			ToBoldlyGoWhereNoButterflyHasGoneBefore();
			break;
		}
		case '3': //"Custom Area"
		{
			LivingInABox(preferences.boxarea.value.split('|'));
			break;
		}
		//case '4', "Chase Mouse Pointer", is handled only in HeartBeat
	}
}

function TheWholeScreenIsYourGarden()
{
	LivingInABox([0, 0, screen.width, screen.height]);
}

function ToBoldlyGoWhereNoButterflyHasGoneBefore()
{
	//expand area to double width and double height of screen
	//thats 4 time the screen, so the butterfly will be off screen most of the time...
	LivingInABox([screen.width * -0.5, screen.height * -0.5, screen.width * 1.5, screen.height * 1.5]);
}

function LivingInABox(box) //box must be an array
{
	//actual flying area do not bound wings, so we need to aplly some corections
	minx = Number(box[0]) - (50 + (body.srcWidth - body.width) / 2);
	miny = Number(box[1]) - (50 + (body.srcWidth - body.width) / 2);
	maxx = Number(box[2]) - (50 + (body.srcWidth - body.width) / 2 + body.width);
	maxy = Number(box[3]) - (50 + (body.srcWidth - body.width) / 2 + body.width);
	//enlarge area if to small to fit butterfly size
	if (maxx - minx < body.width) 
	{
		cx = (minx + maxx) / 2;
		minx = cx - body.width * 0.5;
		maxx = cx + body.width * 0.5;
	}
	if (maxy - miny < body.width) 
	{
		cy = (miny + maxy) / 2;
		miny = cy - body.width * 0.5;
		maxy = cy + body.width * 0.5;
	}
}

function HereIsWhatYouSearchFor(x, y)
{
	LivingInABox([x, y, x, y]);
}

function Init()
{
	if (preferences.boxarea.value == '') preferences.boxarea.value = (screen.width * 0.75 + 8) + '|8|' + (screen.width - 8) + '|' + (screen.height * 0.33 - 8); //default is the right half of screen;
	PrefChanged();
	//start centered
	lastx = mw.hOffset = dummyx.hOffset = (screen.width - mw.width) / 2;
	lasty = mw.vOffset = dummyy.vOffset = (screen.height - mw.height) / 2;
	Stop();
	Fly();
}

function GoX(chase)
{
	delta = Math.random() * body.width * 3;
	if ((Math.random() * 10) > 5) delta = 0 - delta;
	tox = dummyx.hOffset + delta;
	tox = Math.max(minx, Math.min(maxx, tox));
	dur = (Math.abs(tox - dummyx.hOffset) * preferences.speed.value) / Number(preferences.size.value) * 100;
	ease = (chase == true) ? animator.kEaseOut : animator.kEaseInOut;
	if ( ax != undefined ) ax.kill();
	ax = new MoveAnimation(dummyx, tox, 0, dur, ease, GoX);
	animator.start(ax);
	xbeat = 0;
}

function GoY(chase)
{
	delta = Math.random() * body.width * 3;
	if ((Math.random() * 10) > 5) delta = 0 - delta;
	toy = dummyy.vOffset + delta;
	toy = Math.max(miny, Math.min(maxy, toy));
	dur = (Math.abs(toy - dummyy.vOffset) * preferences.speed.value) / Number(preferences.size.value) * 100;
	ease = (chase == true) ? animator.kEaseOut : animator.kEaseInOut;
	if ( ay != undefined ) ay.kill();
	ay = new MoveAnimation(dummyy, 0, toy, dur, ease, GoY);
	animator.start(ay);
	ybeat = 0;
}

function HeartBeat()
{
	//move
	mw.hOffset = dummyx.hOffset; 
	mw.vOffset = dummyy.vOffset;
	
	//rotate based on direction (last position versus current position)	
	if ((lastx - dummyx.hOffset != 0) & (lasty - dummyy.vOffset != 0)) rot = (Math.atan2(lasty - dummyy.vOffset, lastx - dummyx.hOffset)/Math.PI) * 180;
	shadow.rotation = mf.rotation = rot - 90;
	
	//flap|flop
	if (shadow.width == zoomedwidth)
	{
		flap = 1 + Math.random();
		shadow.width = zoomedwidth / (flap * 1.2);
		wing1.width = wing2.width = zoomedwidth / (flap * 1.5);
		wing1.height = wing2.height = zoomedwidth;
		wing1.hOffset = body.hOffset - (Number(preferences.size.value) / 25);
		wing2.hOffset = body.hOffset + (Number(preferences.size.value) / 25);
		shadow.hOffset = shadow.vOffset = mf.hOffset + (Number(preferences.size.value) / 10);
		if (preferences.wingslight.value == '1')
		{	//render light & shadow on wings based on rotation. (rot - 45) sets the sun to top-left corner
			lum = (rot - 45)/ 1.8;	//[-180..180] -> [-100..100]
			if (lum > 50) lum = 100 - lum;
			if (lum < -50) lum = -100 - lum; //[0..-50..0..50..0]
			wing1.hslAdjustment = '0, 0, ' + (-lum);
			wing2.hslAdjustment = '0, 0, ' + lum;
		}
	}
	else
	{
		shadow.width = wing1.width = wing2.width = zoomedwidth;
		wing1.height = wing2.height = zoomedheight;
		wing1.hOffset = wing2.hOffset = body.hOffset;
		wing1.hslAdjustment = wing2.hslAdjustment = '';
	}
	
	//save current position
	lastx = dummyx.hOffset;
	lasty = dummyy.vOffset;

	//fade in ?
	if (preferences.infade.value == 0) mw.opacity = 255;
	if (mw.opacity < 255) mw.opacity += 15;
	
	//Chase Mouse Pointer
	if (flyarea == '4') 
		if ((oldsx != system.event.screenX) | (oldsy != system.event.screenY))
		{
			Stop();
			HereIsWhatYouSearchFor(system.event.screenX, system.event.screenY);
			oldsx = system.event.screenX;
			oldsy = system.event.screenY;
			GoX(true);
			GoY(true);
		}
		
	//It's a butterfly, let it go wild!
	if (preferences.flyarea.value == 0) 
		if (Math.floor(Math.random() * 1000) == 0) IAmNotANumberIAmAFreeButterfly()
}

function IAmNotANumberIAmAFreeButterfly()
{
	newflyarea = flyarea;
	while (newflyarea == flyarea) newflyarea = String(Math.ceil(Math.random() * (preferences.flyarea.option.length - 1)));  //use length - 1 cause we may add more flying rules (any idea?... nobody?...)
	flyarea = newflyarea;
	print("+-->  I'm changing my mind... [" + preferences.flyarea.option[Number(flyarea - 1)] + ']');
	SetFlyingArea();
}

function Stop()
{
	if ( ax != undefined ) ax.kill();
	if ( ay != undefined ) ay.kill();
}

function Fly()
{
	GoX();
	GoY();
}

//
//-----------------------------------------
// edit custom area window functions

function ecawMouseDown()
{
	textandbuttons.visible = false;
	casx = system.event.screenX;
	casy = system.event.screenY;
}

function ecawMouseDrag()
{
	showArea([casx, casy, system.event.screenX, system.event.screenY]);
}

function ecawMouseUp()
{
	textandbuttons.visible = true;
}

function showArea(box)
{
	x1 = Number(box[0]); y1 = Number(box[1]); x2 = Number(box[2]); y2 = Number(box[3]); 
	if (x1 > x2) {tmp = x2; x2 = x1; x1 = tmp}
	if (y1 > y2) {tmp = y2; y2 = y1; y1 = tmp}

	left.hOffset = left.vOffset = top.vOffset = right.vOffset = ecaw.hOffset = ecaw.vOffset = 0;
	left.width = top.hOffset = area.hOffset = bottom.hOffset = x1;
	left.height = right.height = ecaw.height = screen.height;
	top.height = area.vOffset = y1;
	top.width = area.width = bottom.width = x2 - x1;
	area.height = y2 - y1;
	bottom.vOffset = y2;
	bottom.height = screen.height - y2;
	right.hOffset = x2;
	right.width = screen.width - x2;
	ecaw.width = screen.width;
	
	//textandbuttons.hOffset = screen.width / 2;
	//textandbuttons.vOffset = screen.height / 2;

	ecaw.level = "topmost";
}

function ecawOK()
{
	preferences.boxarea.value = area.hOffset + '|' + area.vOffset + '|' + (area.hOffset + area.width) + '|' + (area.vOffset + area.height);
	flyarea = preferences.flyarea.value = '3';
	SetFlyingArea();
	ecawCancel();
}

function ecawCancel()
{
	//avoid fade out
	ecaw.opacity = 0;
	ecaw.visible = false;
	//restore user selected widget opacity
	preferences.konfabulatorWindowOpacity.value = beforeeditwidgetopacity;
	Fly();
}

//
//-----------------------------------------
// edit buttons GUI functions

function enterBtn(who)
{
	who.firstChild.firstChild.opacity = 255;
	who.firstChild.lastChild.opacity = 255;
}

function exitBtn(who)
{
	who.firstChild.firstChild.opacity = 192;
	who.firstChild.lastChild.opacity = 192;
}

function downBtn(who)
{
	who.firstChild.hOffset = 1;
	who.firstChild.vOffset = 1;
	who.firstChild.firstChild.rotation = 180;
}

function upBtn(who)
{
	who.firstChild.hOffset = 0;
	who.firstChild.vOffset = 0;
	who.firstChild.firstChild.rotation = 0;
}

//
//-----------------------------------------
// About boxes at First Display

function doFirstDisplay()
{
	//create a temp window to show about images
	taw = new Window();
	taw.locked = 'true';
	tai =  new Image(taw);
	tai.src = 'Images/About1.png';
	taw.hOffset = (screen.width - tai.width)  / 2;
	taw.vOffset = (screen.height) / 2 - tai.height;
	tai.onMouseDown = nextAbout;
	taw.appendChild(tai);
	tacount = 1;
}

function nextAbout()
{
	taw.visible = false;
	if (tacount < 3)
	{
		tacount += 1;
		tai.src = 'Images/About' + tacount + '.png';
		taw.visible = true;
	}
	else taw.opacity = 0;  //calling 'delete taw;' generates an error....
}
